classification
Title: Update tutorial/modules for PEP 3147
Type: behavior Stage: resolved
Components: Documentation Versions: Python 3.2, Python 3.3
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: eric.araujo Nosy List: JohnRoth1, docs@python, eric.araujo, georg.brandl, python-dev, terry.reedy
Priority: normal Keywords:

Created on 2012-01-31 23:39 by terry.reedy, last changed 2013-10-12 17:12 by python-dev. This issue is now closed.

Messages (4)
msg152415 - (view) Author: Terry J. Reedy (terry.reedy) * (Python committer) Date: 2012-01-31 23:39
http://docs.python.org/py3k/tutorial/modules.html#compiled-python-files
needs to be updated for 3.2+ to reflect 
http://python.org/dev/peps/pep-3147/

The first sentence is still technically correct, but finding x.pyc in the same directory as x.py is now an anomaly, so that sentence, revised, should be near the bottom. Otherwise, the text should say that the default is to put x.<version>.pyc in __pycache__, where <version> is, for instance, 'cpython-32'. Note that this allows other implementations and other versions of cpython to use the same .py file.

I do not know if there is anywhere else that this info is or should be. Using Python?.
msg152582 - (view) Author: John Roth (JohnRoth1) Date: 2012-02-04 02:27
I apologize for not submitting this in patch format, but I don't have a development system available.

I suggest replacing the entire 6.1.3 section with: 

To speed up loading modules, Python caches the compiled version of each module in the __pycache__ directory under the name module.cpython-xy.pyc, where xy is the Python version number. For example, in release 3.2 the compiled version of spam.py would be cached as __pycache__/spam.cpython-32.pyc. This naming convention allows compiled modules from different releases and different versions of Python to coexist.

Python checks the revision date of the source against the compiled version to see if it’s out of date and needs to be recompiled. This is a completely automatic process. Also, the compiled modules are platform-independent, so the same library can be shared among systems with different architectures.

Python does not check the cache in two circumstances. First, it always recompiles and does not store the result for the module that’s loaded directly from the command line. Second, it does not check the cache if there is no source module. To support a non-source (compiled only) distribution, the compiled module must be in the source directory, and there must not be a source module.

Some tips for experts:

* You can use the -O or -OO switches on the Python command to reduce the size of a compiled module. The -O switch removes assert statements, the -OO switch removes both assert statements and __doc__ strings. Neither optimization affects running time, however it’s possible that they may affect run-time behavior. Optimized modules have a .pyo rather than a .pyc suffix. Future releases may change the effects of optimization.

*   The module compileall can create .pyc files (or .pyo files when -O is used) for all modules in a directory.

*   There is more detail on this process, including a flow chart of the decisions, in PEP 3147.
msg199604 - (view) Author: Georg Brandl (georg.brandl) * (Python committer) Date: 2013-10-12 17:12
Thanks for the suggestion!
msg199605 - (view) Author: Roundup Robot (python-dev) (Python triager) Date: 2013-10-12 17:12
New changeset 6ecef57f57f9 by Georg Brandl in branch '3.3':
Closes #13915: update tutorial with respect to .pyc files (__pycache__ / PEP 3147).
http://hg.python.org/cpython/rev/6ecef57f57f9
History
Date User Action Args
2013-10-12 17:12:51python-devsetstatus: open -> closed

nosy: + python-dev
messages: + msg199605

resolution: fixed
stage: needs patch -> resolved
2013-10-12 17:12:46georg.brandlsetnosy: + georg.brandl
messages: + msg199604
2012-02-08 16:27:54eric.araujosettitle: Update Tutorial 6.1.3 for PEP 3145 -> Update tutorial/modules for PEP 3147
2012-02-04 08:20:43eric.araujosetassignee: docs@python -> eric.araujo

nosy: + eric.araujo
2012-02-04 02:28:01JohnRoth1setnosy: + JohnRoth1
messages: + msg152582
2012-01-31 23:39:58terry.reedycreate